//Micro ST beta version 10
//Author Sergey Bulba, svbulba@gmail.com, http://bulba.untergrund.net
//(c)2001-2017 Bulba S.V.

program MicroST;

{$mode objfpc}{$H+}

{$ifdef DebugI}{$ifdef Windows}
{$apptype console}
{$endif}{$endif}

uses
  {$DEFINE UseCThreads}
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Forms, Classes, Interfaces,
  Main, Params, digsound, simpleipc, mc68000, atari, ay, sndh;

{$R *.res}

const
  MainWinTitle = 'Micro ST beta version 10';
  IPCServerName = MainWinTitle + ' IPC';

  function IPCSendParams:boolean;
  var
   i:integer;
  begin
  Result := False;
  with TSimpleIPCClient.Create(nil) do
    try
      ServerID:=IPCServerName;
      if ServerRunning then
       begin
         Active:=True;
         Result := True;
         if ParamCount = 0 then
          SendStringMessage('-v')
         else
          begin
           SendStringMessage('?');
           for i := 1 to ParamCount do
            SendStringMessage(ParamStr(i));
           SendStringMessage('');
          end;
         Active:=False;
       end;
    finally
      Free;
    end;
  end;

  {$ifndef Windows}
  type
   TMessageHook = class(TThread)
         procedure ApplyMessage;
       protected
         procedure Execute; override;
       end;
  var
   MessageHook:TMessageHook;

  procedure TMessageHook.ApplyMessage;
  begin
    IPCServer.PeekMessage(3, True);
  end;

  procedure TMessageHook.Execute;
  begin
    while not Terminated do
    begin
      if IPCServer.Active then
      if IPCServer.PeekMessage(3, False) then
      begin
        Synchronize(@ApplyMessage);
      end;
    end;
  end;
  {$endif}

  procedure StartIPC;
  begin
  IPCServer:=TSimpleIPCServer.Create(Nil);
  IPCServer.ServerID:=IPCServerName;
  IPCServer.Global:=True;
  IPCServer.StartServer;
  {$ifndef Windows}
  MessageHook := TMessageHook.Create(False);
  {$endif}
  end;

  procedure StopIPC;
  begin
  {$ifndef Windows}
    MessageHook.Terminate;
    MessageHook.WaitFor;
    MessageHook.Free;
  {$endif}
    IPCServer.Free;
  end;

begin
FileMode := 0; //ReadOnly for Reset();
{$IFNDEF Windows}
IsConsole := False; //temporary for show exceptions in messagebox instead of linux console
{$ENDIF Windows}
if not IPCSendParams then
 begin
  StartIPC;
  Application.Initialize;
  Application.CreateForm(TForm1, Form1);
  Form1.Caption := MainWinTitle;
  Application.CreateForm(TForm2, Form2);
  Form1.CheckCommandLine;
  Application.Run;
  StopIPC;
 end;
end.
