//Micro ST beta version 10
//Author Sergey Bulba, svbulba@gmail.com, http://bulba.untergrund.net
//(c)2001-2017 Bulba S.V.

unit Params;

{$mode objfpc}{$H+}

interface

uses
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls;

type
  TForm2 = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    ComboBox4: TComboBox;
    Label5: TLabel;
    Button1: TButton;
    Button2: TButton;
    ComboBox5: TComboBox;
    Label6: TLabel;
    Label7: TLabel;
    Edit1: TEdit;
    Label8: TLabel;
    Edit2: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Edit3: TEdit;
    Label11: TLabel;
    Label12: TLabel;
    Edit4: TEdit;
    Label13: TLabel;
    Label14: TLabel;
    Edit5: TEdit;
    Label15: TLabel;
    Label16: TLabel;
    CheckBox1: TCheckBox;
    procedure FormShow(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure SetMainClc(NewFrq:real;Combo:boolean);
    procedure SetMCClc(NewFrq:real;Combo:boolean);
    procedure SetMFPClc(NewFrq:real;Combo:boolean);
    procedure SetYMClc(NewFrq:real;Combo:boolean);
    procedure SetVBClc(NewFrq:real;Combo:boolean);
    procedure ComboBox2Change(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure ComboBox5Change(Sender: TObject);
    function RealEq(a,b:real):boolean;
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure Edit3Change(Sender: TObject);
    procedure Edit4Change(Sender: TObject);
    procedure Edit5Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    MainClc,MCClc,MFPClc,YMClc,VBClc:real;
  end;

var
  Form2: TForm2;

implementation

{$R *.lfm}

uses
  atari, ay;

function TForm2.RealEq(a,b:real):boolean;
const
 Eps = 0.0000001;
begin
Result := Abs(a - b) <= Eps
end;

procedure TForm2.FormShow(Sender: TObject);
begin
MainClc := MainClockFreq;
MCClc := MC68000Freq;
MFPClc := MFPFreq;
YMClc := AyFreq;
VBClc := VBLFreq;
Edit1.Text := FloatToStr(MainClc);
Edit2.Text := FloatToStr(MCClc);
Edit3.Text := FloatToStr(MFPClc);
Edit4.Text := FloatToStr(YMClc);
Edit5.Text := FloatToStr(VBClc);
if RealEq(MainClc,Atari_MainClockFreqDef) then
 begin
  Edit1.ReadOnly := True;
  Edit1.Color := clBtnFace;
  ComboBox1.ItemIndex := 0
 end 
else if RealEq(MainClc,32000000) then
 begin
  Edit1.ReadOnly := True;
  Edit1.Color := clBtnFace;
  ComboBox1.ItemIndex := 1
 end
else
 begin
  Edit1.ReadOnly := False;
  Edit1.Color := clWindow;
  ComboBox1.ItemIndex := 2
 end;
if RealEq(MCClc,MainClc / 4) then
 begin
  Edit2.ReadOnly := True;
  Edit2.Color := clBtnFace;
  ComboBox2.ItemIndex := 0
 end
else if RealEq(MCClc,8000000) then
 begin
  Edit2.ReadOnly := True;
  Edit2.Color := clBtnFace;
  ComboBox2.ItemIndex := 1
 end
else
 begin
  Edit2.ReadOnly := False;
  Edit2.Color := clWindow;
  ComboBox2.ItemIndex := 2
 end;
if RealEq(MFPClc,MainClc / 13) then
 begin
  Edit3.ReadOnly := True;
  Edit3.Color := clBtnFace;
  ComboBox3.ItemIndex := 0
 end
else if RealEq(MFPClc,2457600) then
 begin
  Edit3.ReadOnly := True;
  Edit3.Color := clBtnFace;
  ComboBox3.ItemIndex := 1
 end
else
 begin
  Edit3.ReadOnly := False;
  Edit3.Color := clWindow;
  ComboBox3.ItemIndex := 3
 end;
if RealEq(YMClc,MainClc / 16) then
 begin
  Edit4.ReadOnly := True;
  Edit4.Color := clBtnFace;
  ComboBox4.ItemIndex := 0
 end
else if RealEq(YMClc,2000000) then
 begin
  Edit4.ReadOnly := True;
  Edit4.Color := clBtnFace;
  ComboBox4.ItemIndex := 1
 end
else
 begin
  Edit4.ReadOnly := False;
  Edit4.Color := clWindow;
  ComboBox4.ItemIndex := 3
 end;
if RealEq(VBClc,50.052) then
 begin
  Edit5.ReadOnly := True;
  Edit5.Color := clBtnFace;
  ComboBox5.ItemIndex := 0
 end
else if RealEq(VBClc,50) then
 begin
  Edit5.ReadOnly := True;
  Edit5.Color := clBtnFace;
  ComboBox5.ItemIndex := 1
 end
else if RealEq(VBClc,60) then
 begin
  Edit5.ReadOnly := True;
  Edit5.Color := clBtnFace;
  ComboBox5.ItemIndex := 2
 end
else
 begin
  Edit5.ReadOnly := False;
  Edit5.Color := clWindow;
  ComboBox5.ItemIndex := 3
 end;
CheckBox1.Checked := IsFilt;
end;

procedure TForm2.ComboBox1Change(Sender: TObject);
begin
case ComboBox1.ItemIndex of
0: begin
    Edit1.ReadOnly := True;
    Edit1.Color := clBtnFace;
    SetMainClc(Atari_MainClockFreqDef,True);
   end;
1: begin
    Edit1.ReadOnly := True;
    Edit1.Color := clBtnFace;
    SetMainClc(32000000,True);
   end;
else
   begin
    Edit1.ReadOnly := False;
    Edit1.Color := clWindow;
    Edit1.SelectAll;
    Edit1.SetFocus;
   end;
end;
end;

procedure TForm2.SetMainClc(NewFrq:real;Combo:boolean);
begin
MainClc := NewFrq;
if Combo then
 Edit1.Text := FloatToStr(NewFrq);
if ComboBox2.ItemIndex = 0 then
 SetMCClc(NewFrq / 4,True);
if ComboBox3.ItemIndex = 0 then
 SetMFPClc(NewFrq / 13,True);
if ComboBox4.ItemIndex = 0 then
 SetYMClc(NewFrq / 16,True);
end;

procedure TForm2.SetMCClc(NewFrq:real;Combo:boolean);
begin
MCClc := NewFrq;
if Combo then
 Edit2.Text := FloatToStr(NewFrq);
end;

procedure TForm2.SetMFPClc(NewFrq:real;Combo:boolean);
begin
MFPClc := NewFrq;
if Combo then
 Edit3.Text := FloatToStr(NewFrq);
if ComboBox4.ItemIndex = 2 then
 begin
  YMClc := NewFrq / 1.25;
  Edit4.Text := FloatToStr(YMClc);
 end;
end;

procedure TForm2.SetYMClc(NewFrq:real;Combo:boolean);
begin
YMClc := NewFrq;
if Combo then
 Edit4.Text := FloatToStr(NewFrq);
if ComboBox3.ItemIndex = 2 then
 begin
  MFPClc := NewFrq * 1.25;
  Edit3.Text := FloatToStr(MFPClc);
 end;
end;

procedure TForm2.SetVBClc(NewFrq:real;Combo:boolean);
begin
VBClc := NewFrq;
if Combo then
 Edit5.Text := FloatToStr(NewFrq);
end;

procedure TForm2.ComboBox2Change(Sender: TObject);
begin
case ComboBox2.ItemIndex of
0: begin
    Edit2.ReadOnly := True;
    Edit2.Color := clBtnFace;
    SetMCClc(MainClc / 4,True);
   end;
1: begin
    Edit2.ReadOnly := True;
    Edit2.Color := clBtnFace;
    SetMCClc(8000000,True);
   end;
else
   begin
    Edit2.ReadOnly := False;
    Edit2.Color := clWindow;
    Edit2.SelectAll;
    Edit2.SetFocus;
   end;
end;
end;

procedure TForm2.ComboBox3Change(Sender: TObject);
begin
case ComboBox3.ItemIndex of
0: begin
    Edit3.ReadOnly := True;
    Edit3.Color := clBtnFace;
    SetMFPClc(MainClc / 13,True);
   end;
1: begin
    Edit3.ReadOnly := True;
    Edit3.Color := clBtnFace;
    SetMFPClc(2457600,True);
   end;
2: begin
    Edit3.ReadOnly := True;
    Edit3.Color := clBtnFace;
    SetMFPClc(YMClc * 1.25,True);
   end;
else
   begin
    Edit3.ReadOnly := False;
    Edit3.Color := clWindow;
    Edit3.SelectAll;
    Edit3.SetFocus;
   end;
end;
end;

procedure TForm2.ComboBox4Change(Sender: TObject);
begin
case ComboBox4.ItemIndex of
0: begin
    Edit4.ReadOnly := True;
    Edit4.Color := clBtnFace;
    SetYMClc(MainClc / 16,True);
   end;
1: begin
    Edit4.ReadOnly := True;
    Edit4.Color := clBtnFace;
    SetYMClc(2000000,True);
   end;
2: begin
    Edit4.ReadOnly := True;
    Edit4.Color := clBtnFace;
    SetYMClc(MFPClc / 1.25,True);
   end;
else
   begin
    Edit4.ReadOnly := False;
    Edit4.Color := clWindow;
    Edit4.SelectAll;
    Edit4.SetFocus;
   end;
end;
end;

procedure TForm2.ComboBox5Change(Sender: TObject);
begin
case ComboBox5.ItemIndex of
0: begin
    Edit5.ReadOnly := True;
    Edit5.Color := clBtnFace;
    SetVBClc(50.052,True);
   end;
1: begin
    Edit5.ReadOnly := True;
    Edit5.Color := clBtnFace;
    SetVBClc(50,True);
   end;
2: begin
    Edit5.ReadOnly := True;
    Edit5.Color := clBtnFace;
    SetVBClc(60,True);
   end;
else
   begin
    Edit5.ReadOnly := False;
    Edit5.Color := clWindow;
    Edit5.SelectAll;
    Edit5.SetFocus;
   end;
end;
end;

procedure TForm2.Edit1Change(Sender: TObject);
begin
if Edit1.Modified then
 try
  SetMainClc(StrToFloat(Trim(Edit1.Text)),False)
 except
 end;
end;

procedure TForm2.Edit2Change(Sender: TObject);
begin
if Edit2.Modified then
 try
  SetMCClc(StrToFloat(Trim(Edit2.Text)),False)
 except
 end
end;

procedure TForm2.Edit3Change(Sender: TObject);
begin
if Edit3.Modified then
 try
  SetMFPClc(StrToFloat(Trim(Edit3.Text)),False)
 except
 end;
end;

procedure TForm2.Edit4Change(Sender: TObject);
begin
if Edit4.Modified then
 try
  SetYMClc(StrToFloat(Trim(Edit4.Text)),False)
 except
 end;
end;

procedure TForm2.Edit5Change(Sender: TObject);
begin
if Edit5.Modified then
 try
  SetVBClc(StrToFloat(Trim(Edit5.Text)),False)
 except
 end;
end;

end.
